/*

   Look for value in delimiter separated values file.
	
	
*/

#include <hmg.ch>


#xtranslate VALID <condition> [ MESSAGE <message> ] ;
=> ;
ON LOSTFOCUS _DoValid ( <condition> , <message> )

PROC Main()

    Public _HMG_IsValidInProgres := .F.

    cDSVFNam	:= "EQ_ISINCODE_291117.CSV"  // delimiter separated values file name
	l1stLnIsFN  := .T.                       // First line of DVS file is field names
    cFDelimiter := ","                       // Delimiter
	nFilHandle  := 0
	lFileOpen   := .F.
	lTFileOK    := .F.	
	aFldNams     := {}
	nFieldCo    := 0
	   
    DEFINE WINDOW frmL4V_Main ;
        AT      0, 0 ;
        WIDTH   400 ;
        HEIGHT  400 ;
        TITLE   "Look for value in delimiter separated values file" ;
        ON INIT InitProg( cDSVFNam ) ;
		ON RELEASE CloseFile() ;
        MAIN 
      
        ON KEY ESCAPE ACTION ThisWindow.Release
/*      
	    70,31 PROGRESSBAR Progress_1 ;
        PARENT frmL4V_Main ;
		  RANGE 0,65535 ;
		  WIDTH 450 HEIGHT 20 ;
		  TOOLTIP "ProgressBar"
*/
/*			
	   DEFINE STATUSBAR FONT 'Verdana' SIZE 8   
		   STATUSITEM "" WIDTH 100
		   STATUSITEM "" WIDTH 110
		   DATE          WIDTH 100
		   CLOCK         WIDTH 100
	   END STATUSBARR
*/      
      DEFINE BUTTON btnSearch
         ROW      10
         COL      10
		 CAPTION  "Search ..."
         ACTION   SearchValue()
      END BUTTON // btnSearch
	  		
   END WINDOW // frmL4V_Main

   frmL4V_Main.Center

   frmL4V_Main.Activate
   
RETURN // Main()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROC InitProg( cDSVFile )
    OpenFile( cDSVFile )
	SearchValue()
RETU // InitProg()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROC OpenFile( cDSVFile )

    HB_FUSE()          // Close text file if any
	nFilHandle := 0
    aFldNams    := {}
	nFieldCo   := 0
    	
	IF FILE( cDSVFile )
	   nFilHandle := HB_FUse( cDSVFile )
	   lFileOpen  := nFilHandle > 0	   
	ENDI
	
	IF lFileOpen
	   IF HB_FLastRec() > 0
	      aFldNams := HB_ATOKENS( HB_FReadLn(), cFDelimiter )
		  nFieldCo := LEN( aFldNams )
	   ELSE	  
    	   MsgsTOP( cDSVFile + " file is empty")
	   ENDI
	ELSE
	   MsgsTOP( "Couldn't open " + cDSVFile, "Open Error")
	ENDIF
	
	lTFileOK := lFileOpen .AND. ! EMPTY( aFldNams )
	
RETU // OpenFile()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROC CloseFile()
    IF lFileOpen
       HB_FUSE()
	ENDI   
RETU // CloseFile()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROC SearchValue()    

LOCA aSPars := {} // Search parameters

    LOCA c1Line,;
         nFld2Src,;
         cVal2Src,;
         nFld2Get,;
         cValFound,;
         aFldVals		 
	
    IF lTFileOK
		aSPars := GetSPars( l1stLnIsFN )
		IF !EMPTY( aSPars )
            nFld2Src := aSPars[ 1 ]
            cVal2Src := aSPars[ 2 ]
            nFld2Get := aSPars[ 3 ] 		 
       	    HB_FGoTop()
            WHIL ! HB_FEof()
                aFldVals := HB_ATOKENS( HB_FReadLn(), cFDelimiter )
                IF aFldVals[ nFld2Src ] == cVal2Src
                    cValFound := aFldVals[ nFld2Get ]
			        MsgBox( "Value looking for is: " + cValFound )
			        EXIT
		        ENDIF	  
                HB_FSkip()
			ENDD   
			IF EMPTY( cValFound )
			   MsgStop( "Value looking for is not found" )
			ENDIF   
		ENDIF   
	ENDI // lTFileOK
	
RETU // SearchValue()
	
*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

FUNC GetSPars( ;                // Get Search parameters
               l1stLnIsFNL )    // First line of txt file is fields name list

    LOCA aRVal
	
    DEFINE WINDOW frmGSPars ;
        AT      0, 0 ;
        WIDTH   300 ;
        HEIGHT  200 ;
        TITLE   "Search Parameters" ;		// ON RELEASE CloseFile() ;
        MODAL

        ON KEY ESCAPE ACTION ThisWindow.Release
		
        DEFINE LABEL lblFld2Srch
		    ROW 30
			COL 28
		    VALUE "Field to Search :"
        END LABEL // lblFld2Srch		
		
        DEFINE LABEL lblSrchVal
		    ROW 60
			COL 40
		    VALUE "Search value :"
        END LABEL // lblSrchVal
	
        DEFINE LABEL lblFld2Get
		    ROW 90
			COL 50
		    VALUE "Field to get :"
        END LABEL // lblFld2Get
   
        IF l1stLnIsFNL
            DEFINE COMBOBOX ctbFld2Srch
               ROW 25
               COL 120
               ITEMS aFldNams
			   VALUE 1
            END COMBOBOX // ctbFld2Srch
		ELSE
            DEFINE TEXTBOX ctbFld2Srch
               ROW 25
               COL 120
			   VALUE 1
			   DATATYPE NUMERIC
			   VALID IsInRange( this.value, 1, LEN(aFldNams) )
            END TEXTBOX // ctbFld2Srch
		ENDIF
		
        DEFINE TEXTBOX txbFld2Srch
            ROW 55
            COL 120
        END TEXTBOX // txbFld2Srch
		
        IF l1stLnIsFNL
            DEFINE COMBOBOX ctbFld2Get
                ROW 85
                COL 120
                ITEMS aFldNams
			    VALUE 1
            END COMBOBOX // ctbFld2Get
		ELSE
            DEFINE TEXTBOX ctbFld2Get
               ROW 85
               COL 120
			   VALUE 1
			   DATATYPE NUMERIC
			   VALID IsInRange( this.value, 1, LEN(aFldNams) )
            END TEXTBOX // ctbFld2Get
		ENDIF
				
        DEFINE BUTTON btnApply
            ROW      120
            COL      100
		    CAPTION  "Apply"
            ACTION   aRVal := SetParams()
        END BUTTON // btnApply
	  
	END WINDOW // frmGSPars
	
	frmGSPars.Center
	frmGSPars.Activate
	
RETU aRVal // GetSPars()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

FUNC IsInRange( nVal, nMin, nMax )
RETU (nVal >= nMin .AND. nVal <= nMax )

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

FUNC SetParams() 

LOCA cSrcFld := frmGSPars.ctbFld2Srch.Value ,;
     cSrcVal := frmGSPars.txbFld2Srch.Value ,;
     cGetFld := frmGSPars.ctbFld2Get.Value

LOCA aRVal

    IF !EMPTY( cSrcFld ) .AND. !EMPTY( cSrcVal) .AND. !EMPTY( cGetFld )
       aRVal := { cSrcFld, cSrcVal, cGetFld }
	   frmGSPars.Release
	ENDIF
	
RETU aRVal // SetParams()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

Function _DoValid ( Expression , Message )

	If ValType ( Message ) = "U"
		Message := "Invalid Entry"
	EndIf

	If _HMG_IsValidInProgres

		Return Nil

	Else

		_HMG_IsValidInProgres := .T.
		If ( Expression , Nil , ( MsgStop (Message,'') , This.SetFocus  ) ) 
		_HMG_IsValidInProgres := .F.

	EndIf

Return Nil